# coding: utf-8


"""
IGNORE:
    Nutanix Microseg Versioned APIs

    Manage Network Security Policy configuration of Nutanix clusters.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_microseg_py_client.models.common.v1.config.IPv4Address import IPv4Address  # noqa: F401,E501
from ntnx_microseg_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_microseg_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_microseg_py_client.models.microseg.v4.config.IPv4Range import IPv4Range  # noqa: F401,E501

class AddressGroup(ExternalizableAbstractModel):

    """

    :param name: (:attr:`name`) A short identifier for a address group.
    :type name: required
    :param description: (:attr:`description`) A user defined annotation for a address group.
    :type description: 
    :param ipv4_addresses: (:attr:`ipv4_addresses`) List of CIDR blocks in the address group.
    :type ipv4_addresses: 
    :param ip_ranges: (:attr:`ip_ranges`) List of IP range containing start and end IP.
    :type ip_ranges: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'ipv4_addresses': 'list[common.v1.config.IPv4Address]',
        'ip_ranges': 'list[microseg.v4.config.IPv4Range]',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'ipv4_addresses': 'ipv4Addresses',
        'ip_ranges': 'ipRanges',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, description=None, ipv4_addresses=None, ip_ranges=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__description = None
        self.__ipv4_addresses = None
        self.__ip_ranges = None
        self.discriminator = None
        self.__name = name
        if description is not None:
            self.__description = description
        if ipv4_addresses is not None:
            self.__ipv4_addresses = ipv4_addresses
        if ip_ranges is not None:
            self.__ip_ranges = ip_ranges

    def _initialize_object_type(self):
        return 'microseg.v4.config.AddressGroup'

    def _initialize_fq_object_type(self):
        return 'microseg.v4.r0.a1.config.AddressGroup'


    @property
    def name(self):
        """
        A short identifier for a address group.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if name is not None and len(name) > 64:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `64`")  # noqa: E501

        self.__name = name

    @property
    def description(self):
        """
        A user defined annotation for a address group.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__description

    @description.setter
    def description(self, description):
        if description is not None and len(description) > 1000:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `1000`")  # noqa: E501

        self.__description = description

    @property
    def ipv4_addresses(self):
        """
        List of CIDR blocks in the address group.

        :type:
             list[ :class:`~ntnx_microseg_py_client.models.common.v1.config.IPv4Address` ]
        """  # noqa: E501
        return self.__ipv4_addresses

    @ipv4_addresses.setter
    def ipv4_addresses(self, ipv4_addresses):

        self.__ipv4_addresses = ipv4_addresses

    @property
    def ip_ranges(self):
        """
        List of IP range containing start and end IP.

        :type:
             list[ :class:`~ntnx_microseg_py_client.models.microseg.v4.config.IPv4Range` ]
        """  # noqa: E501
        return self.__ip_ranges

    @ip_ranges.setter
    def ip_ranges(self, ip_ranges):

        self.__ip_ranges = ip_ranges

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(AddressGroup, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AddressGroup):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

