# coding: utf-8


"""
IGNORE:
    Nutanix Microseg Versioned APIs

    Manage Network Security Policy configuration of Nutanix clusters.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_microseg_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_microseg_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_microseg_py_client.models.microseg.v4.config.BannerType import BannerType  # noqa: F401,E501

class BannerResponse(ExternalizableAbstractModel):

    """

    :param banner_type: (:attr:`banner_type`) 
    :type banner_type: 
    :param tier_memory_in_gb: (:attr:`tier_memory_in_gb`) Memory associated with the current mode of operation for cadmus.
    :type tier_memory_in_gb: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'banner_type': 'microseg.v4.config.BannerType',
        'tier_memory_in_gb': 'int',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'banner_type': 'bannerType',
        'tier_memory_in_gb': 'tierMemoryInGB',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, banner_type=None, tier_memory_in_gb=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__banner_type = None
        self.__tier_memory_in_gb = None
        self.discriminator = None
        if banner_type is not None:
            self.__banner_type = banner_type
        if tier_memory_in_gb is not None:
            self.__tier_memory_in_gb = tier_memory_in_gb

    def _initialize_object_type(self):
        return 'microseg.v4.config.BannerResponse'

    def _initialize_fq_object_type(self):
        return 'microseg.v4.r0.a1.config.BannerResponse'


    @property
    def banner_type(self):
        """
        

        :type:
            :class:`~ntnx_microseg_py_client.models.microseg.v4.config.BannerType`
        """  # noqa: E501
        return self.__banner_type

    @banner_type.setter
    def banner_type(self, banner_type):

        self.__banner_type = banner_type

    @property
    def tier_memory_in_gb(self):
        """
        Memory associated with the current mode of operation for cadmus.

        :type:

                :class:`~int`
        """  # noqa: E501
        return self.__tier_memory_in_gb

    @tier_memory_in_gb.setter
    def tier_memory_in_gb(self, tier_memory_in_gb):
        if tier_memory_in_gb is not None and tier_memory_in_gb > 6:  # noqa: E501
            raise ValueError("Invalid value for `tier_memory_in_gb`, must be a value less than or equal to `6`")  # noqa: E501
        if tier_memory_in_gb is not None and tier_memory_in_gb < 2:  # noqa: E501
            raise ValueError("Invalid value for `tier_memory_in_gb`, must be a value greater than or equal to `2`")  # noqa: E501

        self.__tier_memory_in_gb = tier_memory_in_gb

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(BannerResponse, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BannerResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

