# coding: utf-8


"""
IGNORE:
    Nutanix Microseg Versioned APIs

    Manage Network Security Policy configuration of Nutanix clusters.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_microseg_py_client.models.microseg.v4.config.CategoryMappingAdStatus import CategoryMappingAdStatus  # noqa: F401,E501

class CategoryMappingAdInfo(object):

    """A mapping to an object in Active Directory.

    :param directory_service_name: (:attr:`directory_service_name`) The name of the directory service that will be used for mapping.
    :type directory_service_name: 
    :param directory_service_ext_id: (:attr:`directory_service_ext_id`) The extId of the directory service that will be used for mapping.
    :type directory_service_ext_id: 
    :param object_identifier: (:attr:`object_identifier`) The objectGUID for the object in AD.
    :type object_identifier: required
    :param object_path: (:attr:`object_path`) The path for the mapped object in AD.
    :type object_path: 
    :param status: (:attr:`status`) 
    :type status: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'directory_service_name': 'str',
        'directory_service_ext_id': 'str',
        'object_identifier': 'str',
        'object_path': 'str',
        'status': 'microseg.v4.config.CategoryMappingAdStatus',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'directory_service_name': 'directoryServiceName',
        'directory_service_ext_id': 'directoryServiceExtId',
        'object_identifier': 'objectIdentifier',
        'object_path': 'objectPath',
        'status': 'status',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, directory_service_name=None, directory_service_ext_id=None, object_identifier=None, object_path=None, status=None, *args, **kwargs):  # noqa: E501
        self.__directory_service_name = None
        self.__directory_service_ext_id = None
        self.__object_identifier = None
        self.__object_path = None
        self.__status = None
        self.discriminator = None
        if directory_service_name is not None:
            self.__directory_service_name = directory_service_name
        if directory_service_ext_id is not None:
            self.__directory_service_ext_id = directory_service_ext_id
        self.__object_identifier = object_identifier
        if object_path is not None:
            self.__object_path = object_path
        if status is not None:
            self.__status = status
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'microseg.v4.config.CategoryMappingAdInfo'

    def _initialize_fq_object_type(self):
        return 'microseg.v4.r0.a1.config.CategoryMappingAdInfo'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def directory_service_name(self):
        """
        The name of the directory service that will be used for mapping.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__directory_service_name

    @directory_service_name.setter
    def directory_service_name(self, directory_service_name):

        self.__directory_service_name = directory_service_name

    @property
    def directory_service_ext_id(self):
        """
        The extId of the directory service that will be used for mapping.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__directory_service_ext_id

    @directory_service_ext_id.setter
    def directory_service_ext_id(self, directory_service_ext_id):
        if directory_service_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', directory_service_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `directory_service_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__directory_service_ext_id = directory_service_ext_id

    @property
    def object_identifier(self):
        """
        The objectGUID for the object in AD.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__object_identifier

    @object_identifier.setter
    def object_identifier(self, object_identifier):
        if object_identifier is None:
            raise ValueError("Invalid value for `object_identifier`, must not be `None`")  # noqa: E501
        if object_identifier is not None and len(object_identifier) > 200:
            raise ValueError("Invalid value for `object_identifier`, length must be less than or equal to `200`")  # noqa: E501

        self.__object_identifier = object_identifier

    @property
    def object_path(self):
        """
        The path for the mapped object in AD.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__object_path

    @object_path.setter
    def object_path(self, object_path):

        self.__object_path = object_path

    @property
    def status(self):
        """
        

        :type:
            :class:`~ntnx_microseg_py_client.models.microseg.v4.config.CategoryMappingAdStatus`
        """  # noqa: E501
        return self.__status

    @status.setter
    def status(self, status):

        self.__status = status

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(CategoryMappingAdInfo, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CategoryMappingAdInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

