# coding: utf-8


"""
IGNORE:
    Nutanix Microseg Versioned APIs

    Manage Network Security Policy configuration of Nutanix clusters.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_microseg_py_client.models.microseg.v4.config.CategoryMappingAdInfo import CategoryMappingAdInfo  # noqa: F401,E501

class CategoryMappingInfo(object):

    """A mapping from an object to a category value.

    :param category_name: (:attr:`category_name`) The name for the category that this mapping is for.
    :type category_name: required
    :param category_value: (:attr:`category_value`) The value for the category that this mapping is for.
    :type category_value: required
    :param ad_mapping: (:attr:`ad_mapping`) 
    :type ad_mapping: required

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'category_name': 'str',
        'category_value': 'str',
        'ad_mapping': 'microseg.v4.config.CategoryMappingAdInfo',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'category_name': 'categoryName',
        'category_value': 'categoryValue',
        'ad_mapping': 'adMapping',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, category_name=None, category_value=None, ad_mapping=None, *args, **kwargs):  # noqa: E501
        self.__category_name = None
        self.__category_value = None
        self.__ad_mapping = None
        self.discriminator = None
        self.__category_name = category_name
        self.__category_value = category_value
        self.__ad_mapping = ad_mapping
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'microseg.v4.config.CategoryMappingInfo'

    def _initialize_fq_object_type(self):
        return 'microseg.v4.r0.a1.config.CategoryMappingInfo'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def category_name(self):
        """
        The name for the category that this mapping is for.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__category_name

    @category_name.setter
    def category_name(self, category_name):
        if category_name is None:
            raise ValueError("Invalid value for `category_name`, must not be `None`")  # noqa: E501
        if category_name is not None and len(category_name) > 200:
            raise ValueError("Invalid value for `category_name`, length must be less than or equal to `200`")  # noqa: E501

        self.__category_name = category_name

    @property
    def category_value(self):
        """
        The value for the category that this mapping is for.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__category_value

    @category_value.setter
    def category_value(self, category_value):
        if category_value is None:
            raise ValueError("Invalid value for `category_value`, must not be `None`")  # noqa: E501
        if category_value is not None and len(category_value) > 200:
            raise ValueError("Invalid value for `category_value`, length must be less than or equal to `200`")  # noqa: E501

        self.__category_value = category_value

    @property
    def ad_mapping(self):
        """
        

        :type:
            :class:`~ntnx_microseg_py_client.models.microseg.v4.config.CategoryMappingAdInfo`
        """  # noqa: E501
        return self.__ad_mapping

    @ad_mapping.setter
    def ad_mapping(self, ad_mapping):
        if ad_mapping is None:
            raise ValueError("Invalid value for `ad_mapping`, must not be `None`")  # noqa: E501

        self.__ad_mapping = ad_mapping

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(CategoryMappingInfo, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CategoryMappingInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

