# coding: utf-8


"""
IGNORE:
    Nutanix Microseg Versioned APIs

    Manage Network Security Policy configuration of Nutanix clusters.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six

class MigrationConfig(object):

    """__Request body for Actual Config Migration__  It contains two required fields: - forceMonitor - migrateSecuredSubnets 

    :param is_force_monitor: (:attr:`is_force_monitor`) It can only have Boolean values `true` or `false`.<br> If true, force all the policies to be in monitor mode after migration.<br> The policies would remain in same the same state they were pre migration, otherwise. 
    :type is_force_monitor: required
    :param should_migrate_secured_subnets_only: (:attr:`should_migrate_secured_subnets_only`) It can only have Boolean values `true` or `false`.<br> If true, migrate subnets belonging to VMs secured by NSPs.<br> ALL subnets are migrated, otherwise. 
    :type should_migrate_secured_subnets_only: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'is_force_monitor': 'bool',
        'should_migrate_secured_subnets_only': 'bool',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'is_force_monitor': 'isForceMonitor',
        'should_migrate_secured_subnets_only': 'shouldMigrateSecuredSubnetsOnly',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, is_force_monitor=None, should_migrate_secured_subnets_only=None, *args, **kwargs):  # noqa: E501
        self.__is_force_monitor = None
        self.__should_migrate_secured_subnets_only = None
        self.discriminator = None
        self.__is_force_monitor = is_force_monitor
        if should_migrate_secured_subnets_only is not None:
            self.__should_migrate_secured_subnets_only = should_migrate_secured_subnets_only
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'microseg.v4.config.MigrationConfig'

    def _initialize_fq_object_type(self):
        return 'microseg.v4.r0.a1.config.MigrationConfig'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def is_force_monitor(self):
        """
        It can only have Boolean values `true` or `false`.<br> If true, force all the policies to be in monitor mode after migration.<br> The policies would remain in same the same state they were pre migration, otherwise. 

        :type:

                :class:`~bool`
        """  # noqa: E501
        return self.__is_force_monitor

    @is_force_monitor.setter
    def is_force_monitor(self, is_force_monitor):
        if is_force_monitor is None:
            raise ValueError("Invalid value for `is_force_monitor`, must not be `None`")  # noqa: E501

        self.__is_force_monitor = is_force_monitor

    @property
    def should_migrate_secured_subnets_only(self):
        """
        It can only have Boolean values `true` or `false`.<br> If true, migrate subnets belonging to VMs secured by NSPs.<br> ALL subnets are migrated, otherwise. 

        :type:

                :class:`~bool`
        """  # noqa: E501
        return self.__should_migrate_secured_subnets_only

    @should_migrate_secured_subnets_only.setter
    def should_migrate_secured_subnets_only(self, should_migrate_secured_subnets_only):

        self.__should_migrate_secured_subnets_only = should_migrate_secured_subnets_only

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(MigrationConfig, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MigrationConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

