# coding: utf-8


"""
IGNORE:
    Nutanix Microseg Versioned APIs

    Manage Network Security Policy configuration of Nutanix clusters.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
import ntnx_microseg_py_client.models
from ntnx_microseg_py_client.models.OneOfmicroseg.v4.config.MigrationConfigSpecspec import MigrationConfigSpecspec  # noqa: F401,E501

class MigrationConfigSpec(object):

    """__Request body for Config Migration__  It contains two fields: - isDryRun - spec  The spec can be one of two types based on isDryRun boolean value.  A sample request body with the flag set would look like this: ``` { \"isDryRun\": true, \"spec\": {   \"policyNames\" : [],   \"shouldIncludeSecureSubnetsInfo\" : false   } } ```  A sample request body with the flag unset would look like this: ``` { \"isDryRun\": false, \"spec\": {   \"isForceMonitor\" : true,   \"shouldMigrateSecuredSubnetsOnly\" : false   } } ``` 

    :param is_dry_run: (:attr:`is_dry_run`) It can only have Boolean values `true` or `false`.<br> If true, it will trigger a dry run of Flow Config Migration. The policies and subnets will not be actually migrated.<br> If false, the config migration will be triggered.  (**Default** False)
    :type is_dry_run: 
    :param spec: (:attr:`spec`) 
    :type spec: required

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'is_dry_run': 'bool',
        'spec': 'OneOfmicroseg.v4.config.MigrationConfigSpecspec',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'is_dry_run': 'isDryRun',
        'spec': 'spec',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, is_dry_run=False, spec=None, *args, **kwargs):  # noqa: E501
        self.__is_dry_run = None
        self.__spec = None
        self.discriminator = None
        if is_dry_run is not None:
            self.__is_dry_run = is_dry_run
        self.__spec = spec
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'microseg.v4.config.MigrationConfigSpec'

    def _initialize_fq_object_type(self):
        return 'microseg.v4.r0.a1.config.MigrationConfigSpec'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def is_dry_run(self):
        """
        It can only have Boolean values `true` or `false`.<br> If true, it will trigger a dry run of Flow Config Migration. The policies and subnets will not be actually migrated.<br> If false, the config migration will be triggered. 

        :type:

                :class:`~bool`
        """  # noqa: E501
        return self.__is_dry_run

    @is_dry_run.setter
    def is_dry_run(self, is_dry_run):

        self.__is_dry_run = is_dry_run

    @property
    def spec(self):
        """
        

        :type:
                :class:`~ntnx_microseg_py_client.models.microseg.v4.config.MigrationConfig` | 
                :class:`~ntnx_microseg_py_client.models.microseg.v4.config.MigrationSummary`
                    """  # noqa: E501
        return self.__spec

    @spec.setter
    def spec(self, spec):
        if spec is None:
            raise ValueError("Invalid value for `spec`, must not be `None`")  # noqa: E501

        self.__spec = spec

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if attr_type.startswith('OneOf'):
                type = getattr(ntnx_microseg_py_client.models, attr_type.split('.')[-1])
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(MigrationConfigSpec, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MigrationConfigSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

