# coding: utf-8


"""
IGNORE:
    Nutanix Microseg Versioned APIs

    Manage Network Security Policy configuration of Nutanix clusters.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_microseg_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_microseg_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_microseg_py_client.models.microseg.v4.config.NetworkSecurityPolicyRule import NetworkSecurityPolicyRule  # noqa: F401,E501
from ntnx_microseg_py_client.models.microseg.v4.config.PolicyState import PolicyState  # noqa: F401,E501
from ntnx_microseg_py_client.models.microseg.v4.config.PolicyType import PolicyType  # noqa: F401,E501

class NetworkSecurityPolicy(ExternalizableAbstractModel):

    """

    :param name: (:attr:`name`) Name of the Flow Network Security Policy.<br> It can have a maximum length of 63 characters. 
    :type name: required
    :param type: (:attr:`type`) 
    :type type: required
    :param description: (:attr:`description`) A user defined annotation for a policy.
    :type description: 
    :param state: (:attr:`state`) 
    :type state: 
    :param rules: (:attr:`rules`) A list of rules that form a policy. For isolation policies, use isolation rules; for application or quarantine policies, use application rules.
    :type rules: 
    :param is_ipv6_traffic_allowed: (:attr:`is_ipv6_traffic_allowed`) If Ipv6 Traffic is allowed
    :type is_ipv6_traffic_allowed: 
    :param is_hitlog_enabled: (:attr:`is_hitlog_enabled`) If Hitlog is enabled
    :type is_hitlog_enabled: 
    :param vpc_ext_id: (:attr:`vpc_ext_id`) 
    :type vpc_ext_id: 
    :param secured_groups: (:attr:`secured_groups`) 
    :type secured_groups: 
    :param last_update_time: (:attr:`last_update_time`) 
    :type last_update_time: 
    :param creation_time: (:attr:`creation_time`) 
    :type creation_time: 
    :param is_system_defined: (:attr:`is_system_defined`) 
    :type is_system_defined: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'type': 'microseg.v4.config.PolicyType',
        'description': 'str',
        'state': 'microseg.v4.config.PolicyState',
        'rules': 'list[microseg.v4.config.NetworkSecurityPolicyRule]',
        'is_ipv6_traffic_allowed': 'bool',
        'is_hitlog_enabled': 'bool',
        'vpc_ext_id': 'str',
        'secured_groups': 'list[str]',
        'last_update_time': 'datetime',
        'creation_time': 'datetime',
        'is_system_defined': 'bool',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'type': 'type',
        'description': 'description',
        'state': 'state',
        'rules': 'rules',
        'is_ipv6_traffic_allowed': 'isIpv6TrafficAllowed',
        'is_hitlog_enabled': 'isHitlogEnabled',
        'vpc_ext_id': 'vpcExtId',
        'secured_groups': 'securedGroups',
        'last_update_time': 'lastUpdateTime',
        'creation_time': 'creationTime',
        'is_system_defined': 'isSystemDefined',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, type=None, description=None, state=None, rules=None, is_ipv6_traffic_allowed=None, is_hitlog_enabled=None, vpc_ext_id=None, secured_groups=None, last_update_time=None, creation_time=None, is_system_defined=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__type = None
        self.__description = None
        self.__state = None
        self.__rules = None
        self.__is_ipv6_traffic_allowed = None
        self.__is_hitlog_enabled = None
        self.__vpc_ext_id = None
        self.__secured_groups = None
        self.__last_update_time = None
        self.__creation_time = None
        self.__is_system_defined = None
        self.discriminator = None
        self.__name = name
        self.__type = type
        if description is not None:
            self.__description = description
        if state is not None:
            self.__state = state
        if rules is not None:
            self.__rules = rules
        if is_ipv6_traffic_allowed is not None:
            self.__is_ipv6_traffic_allowed = is_ipv6_traffic_allowed
        if is_hitlog_enabled is not None:
            self.__is_hitlog_enabled = is_hitlog_enabled
        if vpc_ext_id is not None:
            self.__vpc_ext_id = vpc_ext_id
        if secured_groups is not None:
            self.__secured_groups = secured_groups
        if last_update_time is not None:
            self.__last_update_time = last_update_time
        if creation_time is not None:
            self.__creation_time = creation_time
        if is_system_defined is not None:
            self.__is_system_defined = is_system_defined

    def _initialize_object_type(self):
        return 'microseg.v4.config.NetworkSecurityPolicy'

    def _initialize_fq_object_type(self):
        return 'microseg.v4.r0.a1.config.NetworkSecurityPolicy'


    @property
    def name(self):
        """
        Name of the Flow Network Security Policy.<br> It can have a maximum length of 63 characters. 

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if name is not None and len(name) > 63:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `63`")  # noqa: E501

        self.__name = name

    @property
    def type(self):
        """
        

        :type:
            :class:`~ntnx_microseg_py_client.models.microseg.v4.config.PolicyType`
        """  # noqa: E501
        return self.__type

    @type.setter
    def type(self, type):
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self.__type = type

    @property
    def description(self):
        """
        A user defined annotation for a policy.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__description

    @description.setter
    def description(self, description):
        if description is not None and len(description) > 512:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `512`")  # noqa: E501

        self.__description = description

    @property
    def state(self):
        """
        

        :type:
            :class:`~ntnx_microseg_py_client.models.microseg.v4.config.PolicyState`
        """  # noqa: E501
        return self.__state

    @state.setter
    def state(self, state):

        self.__state = state

    @property
    def rules(self):
        """
        A list of rules that form a policy. For isolation policies, use isolation rules; for application or quarantine policies, use application rules.

        :type:
             list[ :class:`~ntnx_microseg_py_client.models.microseg.v4.config.NetworkSecurityPolicyRule` ]
        """  # noqa: E501
        return self.__rules

    @rules.setter
    def rules(self, rules):

        self.__rules = rules

    @property
    def is_ipv6_traffic_allowed(self):
        """
        If Ipv6 Traffic is allowed

        :type:

                :class:`~bool`
        """  # noqa: E501
        return self.__is_ipv6_traffic_allowed

    @is_ipv6_traffic_allowed.setter
    def is_ipv6_traffic_allowed(self, is_ipv6_traffic_allowed):

        self.__is_ipv6_traffic_allowed = is_ipv6_traffic_allowed

    @property
    def is_hitlog_enabled(self):
        """
        If Hitlog is enabled

        :type:

                :class:`~bool`
        """  # noqa: E501
        return self.__is_hitlog_enabled

    @is_hitlog_enabled.setter
    def is_hitlog_enabled(self, is_hitlog_enabled):

        self.__is_hitlog_enabled = is_hitlog_enabled

    @property
    def vpc_ext_id(self):
        """
        

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__vpc_ext_id

    @vpc_ext_id.setter
    def vpc_ext_id(self, vpc_ext_id):
        if vpc_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', vpc_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `vpc_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__vpc_ext_id = vpc_ext_id

    @property
    def secured_groups(self):
        """
        

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__secured_groups

    @secured_groups.setter
    def secured_groups(self, secured_groups):

        self.__secured_groups = secured_groups

    @property
    def last_update_time(self):
        """
        

        :type:

                :class:`~datetime`
        """  # noqa: E501
        return self.__last_update_time

    @last_update_time.setter
    def last_update_time(self, last_update_time):

        self.__last_update_time = last_update_time

    @property
    def creation_time(self):
        """
        

        :type:

                :class:`~datetime`
        """  # noqa: E501
        return self.__creation_time

    @creation_time.setter
    def creation_time(self, creation_time):

        self.__creation_time = creation_time

    @property
    def is_system_defined(self):
        """
        

        :type:

                :class:`~bool`
        """  # noqa: E501
        return self.__is_system_defined

    @is_system_defined.setter
    def is_system_defined(self, is_system_defined):

        self.__is_system_defined = is_system_defined

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(NetworkSecurityPolicy, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NetworkSecurityPolicy):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

