# coding: utf-8


"""
IGNORE:
    Nutanix Microseg Versioned APIs

    Manage Network Security Policy configuration of Nutanix clusters.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_microseg_py_client.models.microseg.v4.config.NetworkSecurityPolicyMigrationMetadata import NetworkSecurityPolicyMigrationMetadata  # noqa: F401,E501

class NetworkSecurityPolicyMigrationSummary(object):

    """Specifies the policy name along with the policy metadata.<br> For cases where a single FNS 1.0 policy conversion results in multiple FNS 2.0 policies, it also contains a list of policy metadata corresponding to those system generated policies. 

    :param policy_name: (:attr:`policy_name`) Name of the Flow Network Security Policy.<br> It can have a maximum length of 63 characters. 
    :type policy_name: required
    :param policy_metadata: (:attr:`policy_metadata`) 
    :type policy_metadata: required
    :param system_gen_policy_metadata: (:attr:`system_gen_policy_metadata`) A list of Policy metadata of system generated isolation policies that would get created as part of a successful Flow migration. 
    :type system_gen_policy_metadata: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'policy_name': 'str',
        'policy_metadata': 'microseg.v4.config.NetworkSecurityPolicyMigrationMetadata',
        'system_gen_policy_metadata': 'list[microseg.v4.config.NetworkSecurityPolicyMigrationMetadata]',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'policy_name': 'policyName',
        'policy_metadata': 'policyMetadata',
        'system_gen_policy_metadata': 'systemGenPolicyMetadata',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, policy_name=None, policy_metadata=None, system_gen_policy_metadata=None, *args, **kwargs):  # noqa: E501
        self.__policy_name = None
        self.__policy_metadata = None
        self.__system_gen_policy_metadata = None
        self.discriminator = None
        self.__policy_name = policy_name
        self.__policy_metadata = policy_metadata
        if system_gen_policy_metadata is not None:
            self.__system_gen_policy_metadata = system_gen_policy_metadata
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'microseg.v4.config.NetworkSecurityPolicyMigrationSummary'

    def _initialize_fq_object_type(self):
        return 'microseg.v4.r0.a1.config.NetworkSecurityPolicyMigrationSummary'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def policy_name(self):
        """
        Name of the Flow Network Security Policy.<br> It can have a maximum length of 63 characters. 

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__policy_name

    @policy_name.setter
    def policy_name(self, policy_name):
        if policy_name is None:
            raise ValueError("Invalid value for `policy_name`, must not be `None`")  # noqa: E501

        self.__policy_name = policy_name

    @property
    def policy_metadata(self):
        """
        

        :type:
            :class:`~ntnx_microseg_py_client.models.microseg.v4.config.NetworkSecurityPolicyMigrationMetadata`
        """  # noqa: E501
        return self.__policy_metadata

    @policy_metadata.setter
    def policy_metadata(self, policy_metadata):
        if policy_metadata is None:
            raise ValueError("Invalid value for `policy_metadata`, must not be `None`")  # noqa: E501

        self.__policy_metadata = policy_metadata

    @property
    def system_gen_policy_metadata(self):
        """
        A list of Policy metadata of system generated isolation policies that would get created as part of a successful Flow migration. 

        :type:
             list[ :class:`~ntnx_microseg_py_client.models.microseg.v4.config.NetworkSecurityPolicyMigrationMetadata` ]
        """  # noqa: E501
        return self.__system_gen_policy_metadata

    @system_gen_policy_metadata.setter
    def system_gen_policy_metadata(self, system_gen_policy_metadata):

        self.__system_gen_policy_metadata = system_gen_policy_metadata

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(NetworkSecurityPolicyMigrationSummary, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NetworkSecurityPolicyMigrationSummary):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

