# coding: utf-8


"""
IGNORE:
    Nutanix Microseg Versioned APIs

    Manage Network Security Policy configuration of Nutanix clusters.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_microseg_py_client.models.microseg.v4.config.OptionSpec import OptionSpec  # noqa: F401,E501
from ntnx_microseg_py_client.models.microseg.v4.config.Tier import Tier  # noqa: F401,E501
from ntnx_microseg_py_client.models.microseg.v4.config.TierName import TierName  # noqa: F401,E501

class TierResponse(Tier):

    """

    :param options: (:attr:`options`) List of available tiers
    :type options: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'options': 'list[microseg.v4.config.OptionSpec]',
        'active_tier': 'microseg.v4.config.TierName',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'options': 'options',
        'active_tier': 'activeTier',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, options=None, active_tier=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        Tier.__init__(self, active_tier, ext_id, links, tenant_id, *args, **kwargs)
        self.__options = None
        self.discriminator = None
        if options is not None:
            self.__options = options

    def _initialize_object_type(self):
        return 'microseg.v4.config.TierResponse'

    def _initialize_fq_object_type(self):
        return 'microseg.v4.r0.a1.config.TierResponse'


    @property
    def options(self):
        """
        List of available tiers

        :type:
             list[ :class:`~ntnx_microseg_py_client.models.microseg.v4.config.OptionSpec` ]
        """  # noqa: E501
        return self.__options

    @options.setter
    def options(self, options):

        self.__options = options

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(TierResponse, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TierResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

